smartsens 2.0.0.0

Data Structures | Macros | Functions | Variables
main.c File Reference

Smart Sens Click example. More...

`#include "board.h"`
`#include "log.h"`
`#include "smartsens.h"`

## Data Structures
struct | smartsens_data_orientation
| Euler data. More...

## Macros
#define | EULER 1
| Example parser selector. More...
#define | QUATERNION 0
#define | VECTOR 0
#define | ACCELEROMETER 1
| Vector sensor selector. More...
#define | GYROSCOPE 0
#define | MAGNETOMETER 0
#define | WORK_BUFFER_SIZE 2048

## Functions
void | application_init (void)
void | application_task (void)
void | main (void)

## Variables
uint8_t | work_buffer [WORK_BUFFER_SIZE] = { 0 }
uint8_t | accuracy

## Detailed Description

Smart Sens Click example.

# Description

This example showcases the ability of the Smart Sens click board. It has multiple examples that you can easily select with the defines at the top of the main. There are 5 examples: Euler, Quaternion, and Vector (Accelerometer, Gyroscope, Magnetometer).

The demo application is composed of two sections :

## Application Init

Initialization of communication modules (SPI/I2C) and additional pins(int_pin, rst). After that going through reset sequence and checking device and product IDs, interrupt mask, and host control is set to 0, so every interrupt enabled. If boot status is OK boot sequence is initiated, depending on the defines from the library header it will use RAM or Flash type of the boot. If RAM is selected firmware image first needs to be uploaded to RAM and then it will be booted. If Flash example is selected it will try to boot firmware first if it fails it will then write firmware image to flash and then try to boot it again. When firmware boot is finished Kernel version and Feature registers will be read to check if the firmware is loaded. Then all the callback function will be registered(meta event callback and whatever type of example parser you set), and driver will update the list of virtual sensors present, and finally will configure virtual sensor that will be used in the selected example.

## Application Task

Wait for an interrupt to occur, then read wake-up, non-weak-up, and status FIFO. Parse received data and run the callback parsers to show data on the USB UART.

Note
  Select one of the examples with macros at the top of the main file. Euler example is selected by default. You can choose one of 3 type of parsers: Euler, Quaternion, Vector. If Vector example is selected you choose one of the 3 sensors to show X, Y, and Z values: Accelerometer, Gyroscope, or Magnetometer.

Author
  MikroE Team

## Macro Definition Documentation

## ◆ ACCELEROMETER

#define ACCELEROMETER 1

Vector sensor selector.

Macros for selecting vector's sensor.

## ◆ EULER

#define EULER 1

Example parser selector.

Macros for selecting example and its parser.

## ◆ GYROSCOPE

#define GYROSCOPE 0

## ◆ MAGNETOMETER

#define MAGNETOMETER 0

## ◆ QUATERNION

#define QUATERNION 0

## ◆ VECTOR

#define VECTOR 0

## ◆ WORK_BUFFER_SIZE

#define WORK_BUFFER_SIZE 2048

## Function Documentation

## ◆ application_init()

void application_init | ( | void |  | ) |

< Logger config object.

< Click config object.

Logger initialization. Default baud rate: 115200 Default log level: LOG_LEVEL_DEBUG

Note
  If USB_UART_RX and USB_UART_TX are defined as HAL_PIN_NC, you will need to define them manually for log to work. See LOG_MAP_USB_UART macro definition for detailed explanation.

## ◆ application_task()

void application_task | ( | void |  | ) |

## ◆ main()

void main | ( | void |  | ) |

## Variable Documentation

## ◆ accuracy

uint8_t accuracy

## ◆ work_buffer

uint8_t work_buffer[WORK_BUFFER_SIZE] = { 0 }